<?php
function erzeugeDsvDatei($daten, $wettkampf, $verein = false){
	global $_lagen;
	$verein = $verein===false?TKSWIM_VEREIN:$verein;
	
	$br = "\r\n"; # PHP_EOL geht nicht, da SAM die erzeugten Dateien sonst nicht einlesen kann
	$datinh = '(* Stand: '.date('d.m.Y, H:i').' *)'.$br;
	$datinh .= '(* generiert von: tkswim '.TKSWIM_VERSION.' (->http://tkswim.de/) *)'.$br;
	$datinh .= 'VEREINSMELDELISTE:'.$br;
	$datinh .= 'FORMAT:5;'.$br;
	$datinh .= 'VERANSTALTUNG:'.$wettkampf['titel'].';'.$wettkampf['ort'].';'.$br;
	foreach($daten['abschnitte'] as $row){
		$datinh .= 'ABSCHNITT:'.$row['abschn'].';'.$br;
	}
	foreach($daten['wettkaempfe'] as $row){
		$datinh .= 'WETTKAMPF: '.$row['wknr'].';'.$row['nr'].';'.$row['laenge'].' '.($row['disziplin']==6?'X':$_lagen[$row['disziplin']][0]).' '.$row['mw'].';'.$br;
	}
	$datinh .= 'VEREIN:'.$verein.'; VNKENNZAHL:'.TKSWIM_VEREINSID.'; LSV:'.TKSWIM_LSVKENNZIFFER.'; NATION:GER;'.$br;
	$a = &$daten['ansprechpartner'];
	$datinh .= 'ANSPRECHPARTNER:'.$a['name'].'; '.$a['strasse'].'; '.$a['plz'].'; ';
	$datinh .= $a['ort'].'; Germany; '.$a['tel'].'; '.$a['fax'].'; '.$a['email'].';'.$br;
	if($daten['kampfrichter'] !== false){
		foreach($daten['kampfrichter'] as $kariid => $kari){
			$abschn = array();
			foreach($daten['abschnitte'] as $a){
				$abschn[] = $a['nr'];
			}
			$datinh .= 'KARIMELDUNG: '.$kari['name'].'; '.$kari['gruppe'].'; ABSCHNITTE: '.implode(';',$abschn).';'.$br;
		}
	}
	foreach($daten['einzelstarts'] as $m){
		if(!isset($m['_starts'])){
			continue;
		}
		$datinh .= 'PNMELDUNG: '.$m['name'].';'.$m['dsvid'].';'.$m['mw'].';'.$m['jg'].';;'.$br;
		$wks = $m['_starts'];
		$starts = array();
		foreach($wks as $wk){
			$starts[] = $wk['wknr'].';'.(is_null($wk['zeit'])?($wettkampf['ohnemeldezeit']=='ohnezeit'?'00:00,00':'59:59,99'):text_format($wk['zeit'],'schwimmzeit'));
		}
		if(count($starts) > 0){
			$datinh .= 'STARTS: '.implode('; ',$starts).';'.$br;
		}
	}
	foreach($daten['staffelstarts'] as $s){
		$datinh .= 'STMELDUNG: '.$s['nr'].';;'.$br;
		$datinh .= 'STARTS: '.$s['wknr'].';'.text_format($s['zeit'], 'schwimmzeit').';'.$br;
	}
	$datinh .= 'DATEIENDE';
	return $datinh;
}
# EOF
?>