<?php
require_once('../__inc/_start.inc.php');
$_seite = 18;
$erlaubt = pruefeRechte('m_tools_dsvformulare', 'm_aendern', 'm_tools_mitgliederimportieren');
if(!$erlaubt){
	$_inh = T_KEINZUGRIFF;
}
else{
$_GET['aktion'] = isset($_GET['aktion'])?$_GET['aktion']:'';
switch($_GET['aktion']){
case 'mitgliederimportieren':
	$_tmpl->assign('ueberschrift', 'Mitglieder importieren');
	if(!pruefeRechte('m_tools_mitgliederimportieren')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	if(isset($_GET['anderedatei']) and isset($_SESSION['mitgliederimport'])){
		unset($_SESSION['mitgliederimport']);
	}

	if(!isset($_SESSION['mitgliederimport'])){
		$dateien = parse_ini_file(PFAD_INIDATEIEN.'dateien_tmp.ini');
		$anzeigen = array();
		foreach($dateien as $datei => $daten){
			if(substr($daten,-4) != '.csv'){
				continue;
			}
			list(,$userid,$dateiname) = explode('|',$daten);
			if(!prueferechte('s_dateien_rootzugriff') and $userid != $_SESSION['user']['id']){
				continue;
			}
			$anzeigen[$datei] = $dateiname;
		}
		if(isset($_POST['datei']) and in_array($_POST['datei'],array_keys($anzeigen))){
			$fh = fopen(PFAD_TMP.$_POST['datei'],'r');
			$daten = array();
			while(($dat = fgetcsv($fh, 1000, ';', '"')) !== false){
				$daten[] = $dat;
			}
			fclose($fh);
			if(count($daten[0]) != 14){
				$_tmpl->assign('fehler','Die angegebene CSV-Datei ist ungltig.');
			}
			else{
				$_SESSION['mitgliederimport'] = array();
				require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
				foreach($daten as $row){
					pruefen($row[8], 'telefon', '-');
					$_SESSION['mitgliederimport'][] = array(
						'nachname'    => $row[0],
						'vorname'     => $row[1],
						'gebdatum'    => text_format($row[2], 'dbdatum'),
						'mw'          => $row[3],
						'strasse'     => $row[4],
						'hausnr'      => $row[5],
						'plz'         => $row[6],
						'ort'         => $row[7],
						'telefon'     => $row[8],
						'email'       => $row[9],
						'dsvid'       => $row[10],
						'eingetreten' => text_format($row[11], 'dbdatum'),
						'ausgetreten' => $row[12],
						'attestbis'   => text_format($row[13], 'dbdatum')
					);
				}
				weiterleiten('/mitglieder/tools'.TKSWIM_DATEIENDUNG.'?aktion=mitgliederimportieren', 'die Datei wurde importiert');
			}
		}
		$_tmpl->assign('dateien',$anzeigen);
		$_inh .= $_tmpl->fetch('mitglieder/18.mitgliederimport-dateiformular.inc.html');
	}
	else{
		if(!isset($_POST['speichern'])){
			# Daten nochmal zur Kontrolle ausgeben
			$_tmpl->assign('daten', $_SESSION['mitgliederimport']);
			$_inh .= $_tmpl->fetch('mitglieder/18.mitgliederimport-datenueberpruefen.inc.html');
		}
		else{
			foreach($_SESSION['mitgliederimport'] as $row){
				# Mitglied anlegen
				$query = "INSERT INTO ".DB_PREFIX."mitglieder SET
							dsvid       = ".(empty($row['dsvid'])?'NULL':"'".text_format($row['dsvid'],'db')."'").",
							vorname     = '".text_format($row['vorname'],'db')."',
							nachname    = '".text_format($row['nachname'],'db')."',
							mw          = '".text_format($row['mw'],'db')."',
							gebdatum    = '".text_format($row['gebdatum'],'db')."',
							eingetreten = '".text_format($row['eingetreten'],'db')."',
							ausgetreten = ".(empty($row['ausgetreten'])?'NULL':"'".text_format($row['ausgetreten'],'db')."'").",
							strasse     = '".text_format($row['strasse'],'db')."',
							hausnr      = '".text_format($row['hausnr'],'db')."',
							plz         = '".text_format($row['plz'],'db')."',
							ort         = '".text_format($row['ort'],'db')."',
							email       = '".text_format($row['email'],'db')."',
							attestbis   = ".(empty($row['attestbis'])?'NULL':"'".text_format($row['attestbis'],'db')."'")."";
				$_db->fuehreQueryAus($query);
				$mid = $_db->ergebnis['insertid'];
				#$_inh .= $query.'<br>'; $mid = 'xyz';
				# Telefon anlegen
				if(empty($row['telefon']) or strpos($row['telefon'], '/') === false){
					continue;
				}
				list($v, $n) = explode('/', $row['telefon'], 2);
				$query = "INSERT INTO ".DB_PREFIX."telefon SET
							mitgliedid = ".$mid.",
							telefonart = 1,
							vorwahl    = '".text_format($v, 'db')."',
							nummer     = '".text_format($n, 'db')."'";
				$_db->fuehreQueryAus($query);
				#$_inh .= $query.'<br>';
			}
			$anz = count($_SESSION['mitgliederimport']);
			unset($_SESSION['mitgliederimport']);
			weiterleiten('/mitglieder/tools'.TKSWIM_DATEIENDUNG.'?aktion=mitgliederimportieren', 'Es wurden '.$anz.' Mitglieder importiert.');
		}
	}
	break;

case 'emailsverschicken':
	$_tmpl->assign('ueberschrift', 'E-Mail verschicken');
	if(!pruefeRechte('m_tools_emailsverschicken')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	# einzelne Mitglieder holen
	$query = "SELECT id, CONCAT(nachname, ', ', vorname) as name FROM ".DB_PREFIX."mitglieder
				WHERE email != '' and ausgetreten IS NULL ORDER BY nachname, vorname";
	$_db->holeDaten($query);
	$mitglieder = $_db->baueArray('name','id');

	if(!in_array($_SESSION['user']['id'], array_keys($mitglieder))){
		$_tmpl->assign('fehler', 'Um diese Funktion nutzen zu knnen, muss in den Einstellungen eine eigene E-Mailadresse angegeben sein.');
		break;
	}

	if(isset($_GET['vorlagen'])){



	}
	else{
		$gruppen2mids = array();
		$gruppen = array();
		# bungsleiter holen
		$query = "SELECT m.id as mid, email
					FROM ".DB_PREFIX."uebungsleiter as u LEFT JOIN ".DB_PREFIX."mitglieder as m ON u.mitgliedid=m.id ORDER BY m.id";
		$_db->holeDaten($query);
		$uebungsleiter = $_db->baueArray('email', 'mid');
		$gruppen2mids['uebungsleiter'] = array_keys($uebungsleiter);
		$ulmitemail = 0;
		foreach($uebungsleiter as $email){
			if(!empty($email)){
				$ulmitemail++;
			}
		}
		$gruppen['uebungsleiter'] = 'bungsleiter ('.$ulmitemail.'/'.count($gruppen2mids['uebungsleiter']).')';

		# Kampfrichter holen
		$query = "SELECT m.id as mid, email
					FROM ".DB_PREFIX."kampfrichter as k LEFT JOIN ".DB_PREFIX."mitglieder as m ON k.mitgliedid=m.id ORDER BY m.id";
		$_db->holeDaten($query);
		$kampfrichter = $_db->baueArray('email', 'mid');
		$gruppen2mids['kampfrichter'] = array_keys($kampfrichter);
		$karimitemail = 0;
		foreach($kampfrichter as $email){
			if(!empty($email)){
				$karimitemail++;
			}
		}
		$gruppen['kampfrichter'] = 'Kampfrichter ('.$karimitemail.'/'.count($gruppen2mids['kampfrichter']).')';

		# Vorstand holen
		$query = "SELECT m.id as mid, email
					FROM ".DB_PREFIX."vorstand as v LEFT JOIN ".DB_PREFIX."mitglieder as m ON v.mitgliedid=m.id
					WHERE m.id IS NOT NULL ORDER BY m.id";
		$_db->holeDaten($query);
		$vorstand = $_db->baueArray('email', 'mid');
		$gruppen2mids['vorstand'] = array_keys($vorstand);
		$vmitemail = 0;
		foreach($vorstand as $email){
			if(!empty($email)){
				$vmitemail++;
			}
		}
		$gruppen['vorstand'] = 'Vorstand ('.$vmitemail.'/'.count($gruppen2mids['vorstand']).')';

		# Trainingsgruppen holen
		$query = "SELECT COUNT(t.id) as anzges, t.id as tid, TIME_FORMAT(anfangszeit, '%H:%i') as anfang,
					  TIME_FORMAT(endzeit, '%H:%i') as ende, wochentag, kommentar
					FROM ".DB_PREFIX."mitglieder_trainingsgruppen as mt LEFT JOIN ".DB_PREFIX."trainingsgruppen as t ON t.id=mt.trainingsgruppenid
					WHERE t.id IS NOT NULL GROUP BY t.id ORDER BY wochentag, anfang";
		$_db->holeDaten($query);
		$trainingsgruppen = $_db->baueArray('*','tid');
		  # Mitglieder mit E-Mailadresse holen
		$query = "SELECT  m.id as mid, mt.trainingsgruppenid
					FROM ".DB_PREFIX."mitglieder_trainingsgruppen as mt LEFT JOIN ".DB_PREFIX."mitglieder as m ON m.id=mt.mitgliedid
					WHERE email != '' ORDER BY id, trainingsgruppenid";
		$_db->holeDaten($query);
		$mitgliedermitemail = $_db->baueArray('*','#');
		foreach($mitgliedermitemail as $row){
			if(!isset($gruppen2mids[$row['trainingsgruppenid']])){
				$gruppen2mids[$row['trainingsgruppenid']] = array();
			}
			$gruppen2mids[$row['trainingsgruppenid']][] = $row['mid'];
		}
		foreach($trainingsgruppen as $id => $row){
			if(!isset($gruppen2mids[$id])){
				unset($trainingsgruppen[$id]);
				continue;
			}
		}
		foreach($trainingsgruppen as $id => $gruppe){
			$str = $_wochentage[$gruppe['wochentag']].' '.$gruppe['anfang'].', ';
			$str .= $gruppe['kommentar'].' ('.count($gruppen2mids[$id]).'/'.$gruppe['anzges'].')';
			$gruppen[$id] = $str;
		}

		# inaktive Personen ermitteln
		$query = "SELECT id FROM ".DB_PREFIX."mitglieder WHERE email != '' AND ausgetreten IS NULL ORDER BY id";
		$_db->holeDaten($query);
		$inaktive = $_db->baueArray('id', 'id');
		foreach($gruppen2mids as $gruppe => $mids){
			foreach($mids as $mid){
				if(!isset($inaktive[$mid])){
					continue;
				}
				unset($inaktive[$mid]);
			}
		}
		$gruppen2mids['inaktive'] = array_values($inaktive);

		# Javascript-Array der Gruppen zusammenbauen
		$gruppenjs = 'var gruppen = {'.PHP_EOL;
		$gr = array();
		foreach($gruppen2mids as $gruppe => $mids){
			$gr[] = '  '.$gruppe.' : ['.implode(',',$mids).']';
		}
		$gruppenjs .= implode(','.PHP_EOL, $gr).PHP_EOL;
		$gruppenjs .= '}';
		$vorlageoptionen = array(
			'nicht' => 'nicht speichern',
			'neu'   => 'als neue Vorlage speichern',
			'aktualisieren' => 'Vorlage aktualisieren' # nur wenn eine Vorlage geladen wurde
		);

		# Anhnge
		$anhaenge = array();
		$dateien = parse_ini_file(PFAD_INIDATEIEN.'dateien_tmp.ini');
		require_once(PFAD_INCLUDE.'class/dsv.inc.php');
		$dsv = new dsv;
		foreach($dateien as $datei => $daten){
			list(,$userid,$dateiname) = explode('|',$daten);
			if($userid != $_SESSION['user']['id'] and !prueferechte('s_dateien_rootzugriff')){
				continue;
			}
			$anhaenge[$datei] = $dateiname;
		}



		if(isset($_POST['verschicken'])){

			$d = &$_POST['daten'];
			require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
			$f = '';
			# Empfaenger
			if(!isset($d['empfaenger']) or !is_array($d['empfaenger']) or count($d['empfaenger'])<1){
				$f .= 'Es wurde kein Empfnger angegeben<br />';
			}
			else{
				foreach($d['empfaenger'] as $key => $e){
					if(array_key_exists($e,$mitglieder)){
						continue;
					}
					unset($d['empfaenger'][$key]);
				}
			}

			# Inhalt
			$f .= pruefen($d['betreff'], 'leer', 'Der Betreff fehlt');
			$f .= pruefen($d['betreff'], 'maxlaenge', 'Der Betreff ist zu lang (max. 100 Zeichen)', 100);
			$f .= pruefen($d['text'], 'leer', 'Der Inhalt fehlt');
			$f .= pruefen($d['text'], 'maxlaenge', 'Der Inhalt ist zu lang (max. 65000 Zeichen)', 65000);
			# Anhnge
			if(isset($d['anhaenge']) and is_array($d['anhaenge'])){
				foreach($d['anhaenge'] as $anhang){
					if(isset($anhaenge[$anhang])){
						continue;
					}
					$f .= 'Der Anhang existiert nicht<br />';
				}
			}
			/*
			$c = &$_POST['conf'];
			if($c['zeitpunkt'] == 'datum'){
				$f .= pruefen($c['datum'], 'leer', 'Das Datum an dem die Mail verschickt werden soll, fehlt');
				$f .= pruefen($c['datum'], 'datum', 'Das Datum an dem die Mail verschickt werden soll, ist ungltig');
			}
			*/

			if(empty($f)){
				require_once(PFAD_INCLUDE.'class/mail.inc.php');
				$mail = new email;

				# Allgemeine Dinge durchfhren
				#  Anhnge setzen
				if(isset($_POST['daten']['anhaenge']) and is_array($_POST['daten']['anhaenge'])){
					foreach($_POST['daten']['anhaenge'] as $anhang){
						$mail->setzeAnhang('tmp', $anhang);
					}
				}
				#  Betreff setzen
				$mail->setzeBetreff($_POST['daten']['betreff']);
				#  Empfngerdaten holen
				$query = "SELECT id, vorname, nachname, mw, email FROM ".DB_PREFIX."mitglieder
				            WHERE id IN (".implode(',',$_POST['daten']['empfaenger']).")";
				$_db->holeDaten($query);
				$empfaenger = $_db->baueArray('*','id');

				#  Absender holen
				$query = "SELECT id, vorname, nachname, mw, email FROM ".DB_PREFIX."mitglieder
				            WHERE id = ".$_SESSION['user']['id']."";
				$_db->holeDaten($query);
				$absender = $_db->holeZeile();
				$mail->setzeHeader('Reply-To','"'.$absender['vorname'].' '.$absender['nachname'].'" <'.$absender['email'].'>');

				$_conf = parse_ini_file(PFAD_INCLUDE.'conf/emails.ini', true);
				
				if(!empty($_conf['sonstiges']['fparameter'])){
					$mail->setzeParameter('-f '.$_conf['sonstiges']['fparameter']);
				}

				if($_POST['conf']['einemehrere'] == 'eine'){
					$mail->setzeHeader('From','"'.$absender['vorname'].' '.$absender['nachname'].' (via tkswim)" <'.$_conf['absender']['email'].'>');
					$mail->setzeTextString($_POST['daten']['text']);
					$mail->setzeAn($absender['vorname'].' '.$absender['nachname'].' <'.$absender['email'].'>', false);
					$bcc = array();
					foreach($empfaenger as $row){
						$bcc[] = $row['email'];
					}
					$mail->setzeHeader('BCC', implode(', ',$bcc));
					$mail->verschickeMail();
				}
				else{
					$anmich = false;
					foreach($empfaenger as $row){
						if($row['id']==$_SESSION['user']['id']){
							$anmich = true;
						}
						$mail->setzeHeader('From','"'.$absender['vorname'].' '.$absender['nachname'].' (via tkswim)" <'.$_conf['absender']['email'].'>');
						$mail->setzeTextString($_POST['daten']['text'], $row);
						$mail->setzeAn($row['vorname'].' '.$row['nachname'].' <'.$row['email'].'>', false);
						$mail->verschickeMail();
					}
					if(isset($_POST['conf']['kopieanmich']) and $anmich===false){
						$mail->setzeHeader('From','"'.$absender['vorname'].' '.$absender['nachname'].' (via tkswim)" <'.$_conf['absender']['email'].'>');
						$mail->setzeTextString($_POST['daten']['text'], $absender);
						$mail->setzeAn($absender['vorname'].' '.$absender['nachname'].' <'.$absender['email'].'>', false);
						$mail->verschickeMail();
					}
				}
				weiterleiten('/mitglieder/tools.html?aktion=emailsverschicken', 'Die Mail wurde verschickt');
			}
			else{
				$_tmpl->assign('fehler', $f);
				$conf = $_POST['conf'];
				$daten = $_POST['daten'];
			}

		}
		else{
			# Standardwerte
			$conf = array(
				'einemehrere' => 'mehrere',
				'zeitpunkt'   => 'sofort',
				'inaktiveweg' => true,
				'vorlage'     => 'nicht'
			);
			$daten = array();

		}
		$_tmpl->assign('daten', $daten);
		$_tmpl->assign('conf', $conf);

		$_tmpl->assign('vorlageoptionen', $vorlageoptionen);
	
		
		$_tmpl->assign('anhaenge', $anhaenge);
		$_tmpl->assign('c', ' checked="checked"');
		$_tmpl->assign('gruppen', $gruppen);
		$_tmpl->assign('mitglieder', $mitglieder);
		$_tmpl->tk_javascriptzuweisen('inline', $gruppenjs);
		$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.ui,jquery.tkswim');
		$_tmpl->tk_javascriptzuweisen('onready', "\$('.datumwahl').tkswim_datumwahl({minDate: +1});");
		$_tmpl->tk_javascriptzuweisen('onready', "$('.nojs').css('display','none');");
		$_tmpl->tk_javascriptzuweisen('onready', "$('#quelle ul').selectable({filter: 'li'});");
		$_tmpl->tk_javascriptzuweisen('onready', "$('#ziel ul').selectable({filter: 'li'});");
		$_tmpl->tk_javascriptzuweisen('onready', "$('#quelle-anzahl').text($('#quelle ul li').length);");
		$_tmpl->tk_javascriptzuweisen('onready', "$('.gruppen select').change(function(){
    if($(this).val() == '-'){ return; }
    for(var i=0;i<gruppen[$(this).val()].length;i++){
      $('#m'+gruppen[$(this).val()][i]).addClass('ui-selected');
    }
  });");
		$_tmpl->tk_javascriptzuweisen('onready', "if($('.inaktive').attr('checked')){
    for(var i=0;i<gruppen['inaktive'].length;i++){
      $('#quelle #m'+gruppen['inaktive'][i]).addClass('ui-selected');
    }
    verschieben('quelle', 'inaktive');
  }");
		$_tmpl->tk_javascriptzuweisen('onready', "$('.dazu').click(function(){ verschieben('quelle', 'ziel'); });");
		$_tmpl->tk_javascriptzuweisen('onready', "$('.weg').click(function(){ verschieben('ziel', 'quelle'); });");
		$_tmpl->tk_javascriptzuweisen('onready', "$('.inaktive').change(function(){
    var richtung = $(this).attr('checked')?'weg':'hin';
    if(richtung == 'hin'){
      $('#inaktive li').addClass('ui-selected');
    	verschieben('inaktive', 'quelle');
    }
    else{
      for(var i=0;i<gruppen['inaktive'].length;i++){
        $('#quelle #m'+gruppen['inaktive'][i]).addClass('ui-selected');
      }
      verschieben('quelle', 'inaktive');
    }
  });");

		$_tmpl->tk_javascriptzuweisen('inline', "function verschieben(von, nach){
  $('#'+von+' .ui-selected').clone().prependTo('#'+nach+' ul');
  $('#'+von+' .ui-selected').remove();
  $('#'+nach+' .ui-selected').removeClass('ui-selected');
  $('#'+nach+' .ui-selectable').tkswim_sortiereliste();
  $('#'+von+'-anzahl').text($('#'+von+' ul li').length);
  $('#'+nach+'-anzahl').text($('#'+nach+' ul li').length);
}");
  /*
 		$_tmpl->tk_javascriptzuweisen('onready', "$('#vorlage_conf span').hide(0);
  $('#vorlage_conf span.vorlage_'+$('#vorlage_conf select[name=conf[vorlage]]').val()).show(0);
  $('#vorlage_conf select[name=conf[vorlage]]').change(function(){
    $('#vorlage_conf span').hide(100);
    $('#vorlage_conf span.vorlage_'+$(this).val()).show(100);
  });");*/
		$_inh .= $_tmpl->fetch('mitglieder/18.tools-emailsverschicken.inc.html');
	}



	break;

case 'familienadresse':
	if(isset($_GET['abbrechen']) and isset($_SESSION['familienadresse'])){
		unset($_SESSION['familienadresse']);
		weiterleiten('/mitglieder/tools'.TKSWIM_DATEIENDUNG.'?aktion=familienadresse');
	}
	$_tmpl->assign('ueberschrift', 'Adresse einer Familie ndern');
	if(!isset($_SESSION['familienadresse'])){
		$query = "SELECT GROUP_CONCAT(m.id SEPARATOR ',') as mids, COUNT(m.id) as anz, titel, f.id,
					GROUP_CONCAT(CONCAT(m.vorname, ' (',DATE_FORMAT(gebdatum,'%y'),')') ORDER BY vorname SEPARATOR ', ') as namen,
					CONCAT(strasse, ' ', hausnr, ', ', plz, ' ', ort) as adresse
					FROM ".DB_PREFIX."mitglieder as m LEFT JOIN ".DB_PREFIX."familien as f ON m.familienid=f.id
					WHERE familienid != 0 AND strasse != '' AND ausgetreten IS NULL AND f.id IS NOT NULL
					GROUP BY adresse, titel ORDER BY titel";
		$_db->holeDaten($query);
		$familien = $_db->baueArray('*','#');
		# Familien mit nur einem Mitglied rauswerfen
		foreach($familien as $key => $fam){
			if($fam['anz']==1){
				unset($familien[$key]);
			}
		}
		if(isset($_POST['familienid']) and isset($_POST['mitgliederids'])){
			if(in_array($_POST['familienid'], $_db->baueArray('id','#')) and in_array($_POST['mitgliederids'], $_db->baueArray('mids','#'))){
				$_SESSION['familienadresse'] = array(
					'familienid' => $_POST['familienid'],
					'mids'       => explode(',',$_POST['mitgliederids'])
				);
				weiterleiten('/mitglieder/tools'.TKSWIM_DATEIENDUNG.'?aktion=familienadresse');
			}
		}
		$_tmpl->assign('familien',$familien);
		$_inh .= $_tmpl->fetch('mitglieder/18.familienadresse-familiewaehlen.inc.html');
	}
	else{
		$daten = &$_SESSION['familienadresse'];
		# Familientitel holen
		$query = "SELECT titel FROM ".DB_PREFIX."familien WHERE id = ".$daten['familienid']."";
		$_db->holeDaten($query);
		$daten['titel'] = $_db->holeWert();
		$daten['flags'] = array('aenderungspeichern'=>1);
		# Familienmitglieder holen
		$query = "SELECT id, CONCAT(vorname, ' ', nachname, ' (', YEAR(gebdatum), ')') as name FROM ".DB_PREFIX."mitglieder
					WHERE id IN (".implode(',',$daten['mids']).")";
		$_db->holeDaten($query);
		$mitglieder = $_db->baueArray('name','id');
		$_tmpl->assign('mitglieder',$mitglieder);

		if(!isset($_POST['speichern'])){
			# Adresse als Defaultwert holen
			$query = "SELECT strasse, hausnr, plz, ort FROM ".DB_PREFIX."mitglieder WHERE id = ".$daten['mids'][0]."";
			$_db->holeDaten($query);
			$row = $_db->holeZeile();
			$daten['alteadresse'] = $row;
			$daten['adresse'] = $row;
		}
		else{
			if(isset($_POST['wegzulassende']) and is_array($_POST['wegzulassende'])){
				foreach($_POST['wegzulassende'] as $mid){
					if(($key = array_search($mid, $daten['mids'])) !== false){
						unset($daten['mids'][$key]);
					}
				}
				if(count($daten['mids']) < 1){
					unset($_SESSION['familienadresse']);
					weiterleiten('/mitglieder/tools'.TKSWIM_DATEIENDUNG.'?aktion=familienadresse', 'Es sind keine zu ndernden Mitglieder mehr gespeichert.');
				}
			}
			$f = '';
			require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
			# Adresse
			$f .= pruefen($_POST['adresse']['strasse'],'leer','Die Strae fehlt');
			$f .= pruefen($_POST['adresse']['strasse'],'maxlaenge','Die Strae ist zu lang (max 40 Zeichen)',40);
			$f .= pruefen($_POST['adresse']['hausnr'],'leer','Die Hausnummer fehlt');
			$f .= pruefen($_POST['adresse']['hausnr'],'maxlaenge','Die Hausnummer ist zu lang (max 5 Zeichen)',5);
			$f .= pruefen($_POST['adresse']['plz'],'leer','Die Postleitzahl fehlt');
			$f .= pruefen($_POST['adresse']['plz'],'regexpr','Die Postleitzahl darf nur aus genau 5 Zahlen bestehen','^[0-9]{5}$');
			$f .= pruefen($_POST['adresse']['ort'],'leer','Der Ort fehlt');
			$f .= pruefen($_POST['adresse']['ort'],'maxlaenge','Der Ort ist zu lang (max 40 Zeichen)',40);
			$f .= pruefen($_POST['adresse']['telefonneu'],'telefon','Die Telefonnummer ist ungltig.',$_gleinst['seitenweit']['standardvorwahl']);
			if(!empty($f)){
				$_tmpl->assign('fehler',$f);
				$daten['adresse'] = $_POST['adresse'];
				$daten['flags'] = $_POST['flags'];
			}
			else{
				# Adresse ndern
				$query = "UPDATE ".DB_PREFIX."mitglieder SET
							strasse = '".text_format($_POST['adresse']['strasse'],'db')."',
							hausnr = '".text_format($_POST['adresse']['hausnr'],'db')."',
							plz = '".text_format($_POST['adresse']['plz'],'db')."',
							ort = '".text_format($_POST['adresse']['ort'],'db')."'
							WHERE id IN (".implode(',',$daten['mids']).")";
				$_db->fuehreQueryAus($query);
				# alte Adresse anlegen
				if(isset($_POST['flags']['aenderungspeichern'])){
					$query = "DELETE FROM ".DB_PREFIX."eigenschaften
								WHERE art = 'm' AND eigenschaft = 'alteadresse' AND artid IN (".implode(',',$daten['mids']).")";
					$_db->fuehreQueryAus($query);
					$alteadresse = $daten['alteadresse']['strasse'].' '.$daten['alteadresse']['hausnr'].'|';
					$alteadresse .= $daten['alteadresse']['plz'].' '.$daten['alteadresse']['ort'];
					$tmp = array();
					foreach($daten['mids'] as $mid){
						$tmp[] = "('m',".$mid.",'alteadresse','".text_format($alteadresse,'db')."')";
					}
					$query = "INSERT INTO ".DB_PREFIX."eigenschaften (art, artid, eigenschaft, wert) VALUES ".implode(', ',$tmp)."";
				}
				$_db->fuehreQueryAus($query);

				# Telefonnummer ndern
				if(!empty($_POST['adresse']['telefonneu'])){
					# IDs der zu ndernden Nummern holen
					$query = "SELECT id, mitgliedid FROM ".DB_PREFIX."telefon
								WHERE mitgliedid IN (".implode(',',$daten['mids']).") AND telefonart = 1";
					$_db->holeDaten($query);
					$vorhandene = $_db->baueArray('*','#');
					$mid2telid = array();
					foreach($vorhandene as $row){
						$mid2telid[$row['mitgliedid']] = $row['id'];
					}
					# Telefonnummer neu anlegen bzw. ndern
					list($vorwahl, $nummer) = explode('/', $_POST['adresse']['telefonneu']);
					foreach($daten['mids'] as $mid){
						if(isset($mid2telid[$mid])){
							$query = "UPDATE ".DB_PREFIX."telefon SET
										  vorwahl = '".text_format($vorwahl,'db')."', nummer = '".text_format($nummer,'db')."'
										WHERE id = ".$mid2telid[$mid];
							$_db->fuehreQueryAus($query);
						}
						else{
							$query = "INSERT INTO ".DB_PREFIX."telefon (mitgliedid, telefonart, vorwahl, nummer) VALUES
										(".$mid.", 1, '".text_format($vorwahl,'db')."', '".text_format($nummer,'db')."')";
							$_db->fuehreQueryAus($query);
						}
					}
				}
				unset($_SESSION['familienadresse']);
				weiterleiten('/mitglieder/tools'.TKSWIM_DATEIENDUNG.'?aktion=familienadresse', 'Die Adresse wurde gendert.');
			}
		}
		$_tmpl->assign('daten', $daten);
		$_inh .= $_tmpl->fetch('mitglieder/18.familienadresse-formular.inc.html');
	}
	break;

case 'alteadressenloeschen':
	$_tmpl->assign('ueberschrift','alte Adressen lschen');
	$query = "SELECT m.id, CONCAT(nachname,', ',vorname,' (',mw,', ',DATE_FORMAT(gebdatum,'%d.%m.%Y'),')') as name
				FROM ".DB_PREFIX."mitglieder as m
				LEFT JOIN ".DB_PREFIX."eigenschaften as e ON m.id=e.artid AND e.art='m' AND e.eigenschaft='alteadresse'
				WHERE wert IS NOT NULL ORDER BY nachname, vorname";
	$_db->holeDaten($query);
	if($_db->holeAnzahl() < 1){
		weiterleiten('/mitglieder/tools'.TKSWIM_DATEIENDUNG, 'Es sind keine alten Adressen vorhanden');
	}
	$daten = $_db->baueArray('*','id');
	if(!isset($_POST['weiter'])){
		$_tmpl->assign('daten',$daten);
		$_inh .= $_tmpl->fetch('mitglieder/18.alteadressenloeschen.inc.html');
		break;
	}
	else{
		$f = '';
		if(!isset($_POST['mitglieder']) or !is_array($_POST['mitglieder'])){
			$f .= 'Es wurden keine Mitglieder ausgewhlt.<br />';
		}
		else{
			$zuloeschende = array();
			foreach($_POST['mitglieder'] as $id){
				if(!in_array($id, array_keys($daten))){
					continue;
				}
				$zuloeschende[] = $id;
			}
			if(count($zuloeschende) < 1){
				$f .= 'Es wurden keine Mitglieder ausgewhlt.<br />';
			}
		}
		if(!empty($f)){
			$_tmpl->assign('fehler',$f);
			$_tmpl->assign('daten',$daten);
		}
		else{
			$query = "DELETE FROM ".DB_PREFIX."eigenschaften
						WHERE art='m' AND eigenschaft='alteadresse' AND artid IN (".implode(',',$zuloeschende).")";
			$_db->fuehreQueryAus($query);
			$anz = count($zuloeschende);
			$text = 'Es wurde'.($anz==1?' 1 alte Adresse':'n '.$anz.' alte Adressen').' gelscht';
			weiterleiten('/mitglieder/tools'.TKSWIM_DATEIENDUNG, $text);
		}
	}
	$_inh .= $_tmpl->fetch('mitglieder/18.alteadressenloeschen.inc.html');
	break;

case 'dsvformulare_startrechtwechsel':
	if(!pruefeRechte('m_tools_dsvformulare')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	$_tmpl->assign('ueberschrift','DSV-Formulare - Startrechtwechsel');
	if(isset($_GET) and isset($_GET['id'])){
		$query = "SELECT id, nachname, vorname FROM ".DB_PREFIX."mitglieder WHERE id = '".text_format($_GET['id'],'db')."'";
		$_db->holeDaten($query);
		if($_db->holeAnzahl() != 1 or $_GET['id'] != $_db->holeWert('id')){
			$_tmpl->assign('fehler','das gewhlte Mitglied existiert nicht.');
			unset($_GET['id']);
		}
		else{
			$mitglied = $_db->holeZeile();
		}
	}

	if(!isset($_GET['id'])){
		require_once(PFAD_INCLUDE.'func/mitgliedwaehlen.inc.php');
		$_inh .= mitgliedwaehlen('/mitglieder/tools'.TKSWIM_DATEIENDUNG, 'aktion=dsvformulare_startrechtwechsel');
	}
	else{
		$query = "SELECT v.id, mitgliedid,
					CONCAT(v.bezeichnung, ' (', IF(m.nachname IS NULL,'-',CONCAT(vorname,' ',nachname)),')') as bezeichnung
					FROM ".DB_PREFIX."vorstand as v LEFT JOIN ".DB_PREFIX."mitglieder as m ON v.mitgliedid = m.id ORDER BY v.sort";
		$_db->holeDaten($query);
		$vorstand = $_db->baueArray('mitgliedid','id');
		$_tmpl->assign('vorstand',$_db->baueArray('bezeichnung','id'));
		if(!isset($_POST['speichern'])){ # Formular mit sonstigen Daten
			$daten = array(
				'verein' => array(
					'ansprechpartner' => 4
				),
				'schwimmer' => array(
					'staat' => '',
					'id' => $_GET['id'],
					'name' => $mitglied['nachname'].', '.$mitglied['vorname']
				)
			);
			$_tmpl->assign('daten',$daten);
		}
		else{ # pruefen
			require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
			$f = '';
			$d = &$_POST['daten'];
			# Vorstand
			$f .= pruefen($d['verein']['ansprechpartner'],'wertemenge','Der Ansprechpartner ist ungltig',array_keys($vorstand));
			if(empty($f) and is_null($vorstand[$d['verein']['ansprechpartner']])){
				$f .= 'Dem Vorstandsamt ist kein Mitglied zugewiesen<br />';
			}
			# Schwimmer
			$f .= pruefen($d['schwimmer']['staat'],'maxlaenge','Die Staatsangehrigkeit ist zu lang (max. 15 Zeichen)',15);
			# Anhaenge
			if(!isset($d['beigefuegt']['freigabe'])){
				$f .= 'Der Wert fr die Freigabebescheinigung fehlt.<br />';
			}
			else{
				if(!in_array($d['beigefuegt']['freigabe'],array('freigabebescheinigung','anforderung'))){
					$f .= 'Der Wert fr die Freigeabebescheinigung ist ungltig.<br />';
				}
			}
			if(!isset($d['beigefuegt']['verwaltungsgebuehr'])){
				$f .= 'Der Wert fr die Verwaltungsgebhr fehlt.<br />';
			}
			else{
				if(!in_array($d['beigefuegt']['verwaltungsgebuehr'],array('vrscheck','ueberweisungsbeleg','einzugsermaechtigung'))){
					$f .= 'Der Wert fr die Verwaltungsgebhr ist ungltig.<br />';
				}
				elseif($d['beigefuegt']['verwaltungsgebuehr'] == 'vrscheck'){
					$f .= pruefen($d['beigefuegt']['vrschecknr'],'maxlaenge','Die Nummer des VR-Schecks ist zu lang (max. 22 Zeichen)',22);
				}
			}
			# alter Verein
			$f .= pruefen($d['erkl']['name_alt'],'maxlaenge','Der Vereinsname des alten Vereines ist zu lang (max. 32 Zeichen)',32);
			$f .= pruefen($d['erkl']['id_alt'],'regexpr','Die ID des alten Vereines ist ungltig (sie muss genau 4 Zeichen lang sein und darf nur aus Ziffern bestehen)','^[0-9]{4}$');
			$f .= pruefen($d['erkl']['datum'],'datum','Das Datum ist ungltig');

			if(!empty($f)){
				$_tmpl->assign('fehler',$f);
				$_tmpl->assign('daten',$_POST['daten']);
			}
			else{
				require_once(PFAD_INCLUDE.'class/ooodateien.inc.php');
				$ooo = new ooodateien($_tmpl,'startrechtwechsel');
				# Daten einsammeln
				# Ansprechpartner
				$query = "SELECT CONCAT(nachname,', ',vorname) as name, email, CONCAT(strasse,' ',hausnr,', ',plz,' ',ort) as anschrift
							FROM ".DB_PREFIX."mitglieder WHERE id = ".$vorstand[$d['verein']['ansprechpartner']]."";
				$_db->holeDaten($query);
				$row = $_db->holeZeile();
				$query = "SELECT CONCAT(vorwahl,'/',nummer) as nr, telefonart FROM ".DB_PREFIX."telefon
							WHERE mitgliedid = ".$vorstand[$d['verein']['ansprechpartner']]." AND telefonart IN (1,4)";
				$_db->holeDaten($query);
				$row['tel'] = '-';
				$row['fax'] = '-';
				if($_db->ergebnis['anzahl'] != 0){
					$tel = $_db->baueArray('nr','telefonart');
					if(isset($tel[1])){
						$row['tel'] = $tel[1];
					}
					if(isset($tel[4])){
						$row['fax'] = $tel[4];
					}
				}
				$verein = array(
					'name'         => TKSWIM_VEREIN,
					'id'           => TKSWIM_VEREINSID,
					'ap_name'      => $row['name'],
					'ap_anschrift' => $row['anschrift'],
					'ap_tel'       => $row['tel'],
					'ap_fax'       => $row['fax'],
					'ap_email'     => $row['email']
				);
				# Schwimmer
				$query = "SELECT nachname, vorname, dsvid, DATE_FORMAT(gebdatum,'%d.%m.%Y') as gebdat, mw,
							CONCAT(strasse,' ',hausnr,', ',plz,' ',ort) as anschrift
							FROM ".DB_PREFIX."mitglieder WHERE id = ".$_GET['id']."";
				$_db->holeDaten($query);
				$row = $_db->holeZeile();
				$dateinamenname = strtolower($row['vorname'].'-'.$row['nachname']);
				$dateinamenname = str_replace(array('','','',''),array('ae','oe','ue','ss'),$dateinamenname);
				$dateinamenname = preg_replace('~[^a-z0-9_-]~','',$dateinamenname);
				$schwimmer = array(
					'nachname'  => $row['nachname'],
					'vorname'   => $row['vorname'],
					'id'        => $row['dsvid'],
					'gebdat'    => $row['gebdat'],
					'anschrift' => $row['anschrift'],
					'staat'     => $_POST['daten']['schwimmer']['staat'],
					'm'         => ($row['mw']=='m'),
					'w'         => ($row['mw']=='w')
				);
				# beigefuegt
				$beigefuegt = array(
					'freigabebescheinigung' => $_POST['daten']['beigefuegt']['freigabe']=='freigabebescheinigung',
					'anforderung'           => $_POST['daten']['beigefuegt']['freigabe']=='anforderung',
					'vrscheck'              => $_POST['daten']['beigefuegt']['verwaltungsgebuehr']=='vrscheck',
					'ueberweisungsbeleg'    => $_POST['daten']['beigefuegt']['verwaltungsgebuehr']=='ueberweisungsbeleg',
					'einzugsermaechtigung'  => $_POST['daten']['beigefuegt']['verwaltungsgebuehr']=='einzugsermaechtigung',
					'liegtdemdsvvor'        => false,
					'vrschecknr'             => ''
				);
				if($beigefuegt['vrscheck']){
					$beigefuegt['vrschecknr'] = $_POST['daten']['beigefuegt']['vrschecknr'];
				}
				if($beigefuegt['einzugsermaechtigung'] and isset($_POST['daten']['beigefuegt']['einzugsermaechtigungliegtvor'])){
					$beigefuegt['liegtdemdsvvor'] = true;
				}
				# Erklaerung
				$erklaerung = array(
					'name_alt' => $_POST['daten']['erkl']['name_alt'],
					'id_alt'   => $_POST['daten']['erkl']['id_alt'],
					'datum'    => $_POST['daten']['erkl']['datum'],
					'name_neu' => TKSWIM_VEREIN,
					'id_neu'  => TKSWIM_VEREINSID
				);
				# Meta-Daten
				$titlename = htmlspecialchars($schwimmer['vorname'].' '.$schwimmer['nachname']);
				$titlename = str_replace(array('','','',''),array('ae','oe','ue','ss'),$titlename);
				$_meta = array(
					'generator' => 'tkswim '.TKSWIM_VERSION,
					'titel'     => 'Antrag auf Startrechtwechsel fuer '.$titlename.' (DSV-Form 003)',
					'creator'   => $_SESSION['user']['realname'],
					'date'      => date('Y-m-d\TH:i:s')
				);
				# Daten an Klasse uebergeben
				$ooo->setzeWerte('_meta',$_meta);
				$ooo->setzeWerte('beigefuegt',$beigefuegt);
				$ooo->setzeWerte('erkl',$erklaerung);
				$ooo->setzeWerte('schwimmer',$schwimmer);
				$ooo->setzeWerte('verein',$verein);
				$ooo->setzeEinstellung('ooo:configuration-settings','AddParaTableSpacingAtStart','boolean',true);
				# Datei generieren
				$ooo->generiereDateien();
				$ooo->setzeDateiname('startrechtwechsel_'.$dateinamenname.'.odt');
				$ooo->gebeOooDateiAus();
			}
		}
		$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.ui,jquery.tkswim');
		$_tmpl->tk_javascriptzuweisen('onready', "\$('.datumwahl').tkswim_datumwahl();");
		$_inh .= $_tmpl->fetch('mitglieder/18.startrechtwechsel-formular.inc.html');
	}
	break;
default:
	$_tmpl->assign('ueberschrift','Tools zum Bearbeiten o.. der Mitgliederdaten');
	$_inh .= $_tmpl->fetch('mitglieder/18.tools-index.inc.html');
	break;
}
} # Ende Rechte-else
require_once('../__inc/_ende.inc.php');
# EOF
?>